/*****************************************************************

  button.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/


class GVButtonSkin;

// Class for a skinned button

class GVButton
  {
  enum State
  {
    Normal,
    Highlight,
    Pressed
  };

  State state;
  
  const GVButtonSkin * skin;
  
  GdkGC * gc;
    
  GtkWidget * drawingarea;

  GtkWidget * parent; // Parent (Must be GtkLayout)
  
  // Position information
  
  int width;
  int height;

  int is_realized;
  
public:

  GVButton(GtkWidget * _parent);
  
  void expose_callback();
  void realize_callback();
  void callback(GdkEventAny * event);

  void set_style_callback();
  
  // This is called when the button is pressed

  gpointer press_callback_data;
  
  void (*press_callback)(GVButton * button, gpointer callback_data);

  void set_skin(const GVButtonSkin * _skin);

  GtkWidget * menu;
    
  };
