/*****************************************************************

  cw_spinbutton.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Methods for several configuration widgets

#include "config.h"

#include <gtk/gtk.h>

#include "configwindow.h"
#include "gtkutil.h"

GVConfigWidgetSpinbutton::GVConfigWidgetSpinbutton(const char * _label,
                                                   float lower, float upper,
                                                   int num_digits)
  {
  adjustment = gtk_adjustment_new(lower, lower, upper, 1.0, 0.0, 0.0);
  spinbutton = gtk_spin_button_new(GTK_ADJUSTMENT(adjustment), 0.1, num_digits);
  gtk_widget_show(spinbutton);

  label = gtk_label_new(_label);
  gtk_widget_show(label);
  }

float GVConfigWidgetSpinbutton::get_value()
  {
  return gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spinbutton));
  }

void GVConfigWidgetSpinbutton::set_value(float _val)
  {
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(spinbutton), _val);
  }

void GVConfigWidgetSpinbutton::attach(GtkWidget * table, int row, int column)
  {
  gvgtk_table_attach_noresize(table, label, column, column+1, row, row+1);
  gtk_table_attach_defaults(GTK_TABLE(table), spinbutton,
                            column+1, column+2, row, row+1);
  }

void GVConfigWidgetSpinbutton::set_sensitive(int sensitive)
  {
  gtk_widget_set_sensitive(spinbutton, sensitive);
  gtk_widget_set_sensitive(label, sensitive);
  }
