/*****************************************************************

  cw_stringmenu.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Configure a string

#include "config.h"

#include <gtk/gtk.h>
#include <string.h>

#include "configwindow.h"
#include "gtkutil.h"

void GVConfigWidgetStringmenu::set_string(const char * _string)
  {
  if(_string)
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo)->entry),
                       _string);
  }

const char * GVConfigWidgetStringmenu::get_string()
  {
  return gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo)->entry));
  }

GVConfigWidgetStringmenu::GVConfigWidgetStringmenu(const char * _label,
                                                   char ** _strings,
                                                   int num)
  {
  combo = gtk_combo_new();
  strings = (GList*)0;

  for(int i = 0; i < num; i++)
    strings = g_list_append(strings, (gpointer)(_strings[i]));
  
  gtk_combo_set_popdown_strings(GTK_COMBO(combo), strings);
  
  label = gtk_label_new(_label);
  
  gtk_widget_show(label);
  gtk_widget_show(combo);
  }

void GVConfigWidgetStringmenu::attach(GtkWidget * table, int row, int column)
  {
  gvgtk_table_attach_noresize(table, label, column, column+1, row, row+1);
  gtk_table_attach_defaults(GTK_TABLE(table), combo,
                            column+1, column+2, row, row+1);
  }

GVConfigWidgetStringmenu::~GVConfigWidgetStringmenu()
  {
  g_list_free(strings);
  }

void GVConfigWidgetStringmenu::set_sensitive(int sensitive)
  {
  gtk_widget_set_sensitive(combo, sensitive);
  gtk_widget_set_sensitive(label, sensitive);
  }
