/*****************************************************************

  globalconfig.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Global configuration values which are visible for every module

#ifdef __GNUG__
#pragma interface
#endif


class GVGlobalConfig
  {
  void get_config();
  void put_config();

  class ConfigWidget : public GVConfigWidget
    {
    GVGlobalConfig * global_config;
    
    GVConfigWidgetFile output_directory;
    GVConfigWidgetSpinbutton singlepic_framerate;

    GVConfigWidgetColor alpha_background;
    
    GtkWidget * auto_advance;
    GtkWidget * start_play;

    GtkWidget * use_mmx;

    // Allow multiple instances, not implemented yet

    GtkWidget * allow_multiple;

    // Remove tracks from the playlist if they cause an error
    
    GtkWidget * remove_error_tracks;
    
    GtkWidget * delete_incomplete;
    
  public:

    ConfigWidget(GVGlobalConfig * _global_config);
    virtual ~ConfigWidget();
    
    void apply_values();
    void get_values();
    };

  class NetworkConfigWidget : public GVConfigWidget
    {
    GVConfigWidgetString http_proxy_server;  // Adress of the proxy server
    GVConfigWidgetSpinbutton http_proxy_port; // http Proxy port
    GtkWidget * use_http_proxy;              // Use proxy at all
    GtkWidget * use_http_proxy_env;          // Take proxy from environment
    GVGlobalConfig * global_config;
   
  public:

    NetworkConfigWidget(GVGlobalConfig * _global_config);
    virtual ~NetworkConfigWidget();

    void apply_values();
    void get_values();
    };
  
public:

  ConfigWidget config_widget;
  NetworkConfigWidget network_config_widget;
  
  char * output_directory;

  char * trackname_mask;

  int use_track_info;
  float singlepic_framerate;

  // HTTP stuff

  char * http_proxy_server;
  int http_proxy_port;
  int http_use_proxy;
  int http_use_proxy_env;

  // Background color for converting colorspaces with alpha
  // channel to colorspaces without alpha

  guchar alpha_background[3];
  
  GVGlobalConfig();
  ~GVGlobalConfig();
  };

extern GVGlobalConfig * gv_global_config;
