/*****************************************************************

  gvtime.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Time variable

#include "config.h"

#include <unistd.h>
#include <glib.h>
#include "gvtime.h"
// #include <time.h>

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include <stdio.h>
void GVTime::sleep()
  {
  //  int microseconds = seconds + nanoseconds / 1000;
  // usleep(microseconds);

  struct timeval delay_duration;

  delay_duration.tv_sec = seconds;
  delay_duration.tv_usec = nanoseconds / 1000;
  
  select(0,  NULL,  NULL, NULL, &delay_duration);
  }

void GVTime::print(char * comment,char *  end="")
  {
    
   //double time = seconds + (double) nanoseconds / GV_NANOSEC_PER_SEC;
   //printf("%s %.3lf%s",comment,time,end);
  }

guint64 GVTime::get_samples(unsigned int samplerate)
  {
  if(undefined())
    return 0;
  else
    return samplerate * seconds + (samplerate * nanoseconds / 1000000000);
  }

int GVTime::get_frames(double framerate)
  {
  if(undefined())
    return 0;
  else
    return (int)((framerate*seconds + framerate*nanoseconds/1000000000.0)+0.5);
  }
