/*****************************************************************

  gvutil.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Mixed utility routines

#define STRING_DELIMITER '"'
#define NULL_STRING "NULL"

#include "config.h"
#include <iostream>
using std::ostream;
using std::cerr;

#include "gvutil.h"

#include <string.h>
#include <ctype.h>


const char * gv_read_string(char * line, char ** _end)
  {
  char * start;
  char * end;

  start = line;

  while(isspace(*start) && (*start != '\0'))
    start++;

  if(*start == '\0')
    return (char*)0;

  if(!strncmp(start, NULL_STRING, strlen(NULL_STRING)))
    {
    *_end = &(start[strlen(NULL_STRING)]);
    //    cerr << "found NULL String, rest: " << *_end << "\n";
    return (char*)0;
    }

  if(*start != STRING_DELIMITER)
    {
    *_end = &(start[strlen(start)]);
    return start;
    }
  
  start++;
  if(*start == '\0')
    return (char *)0;

  // start is now correct

  end = start+1;
  
  if(end == '\0')
    return (char *)0;

  while(1)
    {
    if((*end == STRING_DELIMITER) && (*(end-1) != '\\'))
      break;
    end++;
    if(end == '\0')
      return (char *)0;
    }
  *end = '\0';
  *_end = end + 1;
  return start;
  }

void gv_write_string(ostream & output, char * string)
  {
  if(!string)
    {
    output << NULL_STRING;
    return;
    }
  output << '"';

  int len = strlen(string);

  for(int i = 0; i < len; i++)
    {
    if(string[i] == '"')
      output << '\\' << string[i];
    else
      output << string[i];
    }

  output << '"';
  }
