/*****************************************************************

  infowindow.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Info window

class GVLabel;

class GVInfoWindow
  {
  GtkWidget * notebook;

  GVLabel * track_info;
  
  GVLabel * input_audio_format;
  GVLabel * input_video_format;
  
  GVLabel * output_audio_format;
  GVLabel * output_video_format;

  GVLabel * input_info;
  GVLabel * output_audio_info;
  GVLabel * output_video_info;

  GtkWidget * plugins_list;
  GVLabel * plugins_description;
    
  GtkWidget * close_button;

  GtkWidget * window;

  int visible;

  const GVPluginInfo ** plugin_infos;

  int num_plugins;
  
public:

  int is_visible() { return visible;}
  
  void show();
  void hide();

  void update();
  void update_plugins();

  GVInfoWindow();

  void select_row_callback(int row);
  
  };


extern GVInfoWindow * gv_info_window;
