/*****************************************************************

  output.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

class GVBufferAudio;
class GVBufferVideo;

class GVOutput : public GVPlugin
  {
protected:

  // Creates the filename from the trackname of the input by prepending
  // the default output directory and appending the suffix
  
  unsigned int video_frames_written;
  guint64 audio_samples_written;

  virtual void put_frame(GVAudioFrame * frame);
  virtual void put_frame(GVVideoFrame * frame);

  GVOutput(const GVPluginAttributes * _attributes);

  virtual void create_trackname();

  virtual int create_outfilename(const char * suffix);
  
public:

  virtual ~GVOutput();
  
  GVInput * input;

  virtual void alloc_frames(GVVideoFrame * frames, int num_frames);
  
  virtual void free_frames(GVVideoFrame * frames, int num_frames);

  virtual void alloc_frames(GVAudioFrame * frames, int num_frames);
  
  virtual void free_frames(GVAudioFrame * frames, int num_frames);

  virtual void playback_func(); // Playback Function

  void resync(); // Get the current times from the input plugin
  };
