#ifndef AVIFILE_AVIMEDIAREADHANDLER_H
#define AVIFILE_AVIMEDIAREADHANDLER_H

#include "Cache.h"
#include "ReadHandlers.h"

class AviMediaReadStream;

class AviMediaReadHandler : public IMediaReadHandler
{
friend class AviMediaReadStream;
    MainAVIHeader m_MainHeader;
    avm::vector<AviMediaReadStream> m_Streams;
protected:
    InputStream m_Input;
public:
    AviMediaReadHandler(const char* pszFile) throw(FatalError);
    virtual ~AviMediaReadHandler();
    virtual HRESULT GetHeader(void* pheader, uint_t size) const;
    virtual IMediaReadStream* GetStream(fourcc_t fccType, uint_t lParam);
    virtual bool GetURLs(avm::vector<avm::string>& urls) const { return false; }
    virtual void Interrupt() {}
    /* avi files are opened synchronously */
    virtual bool IsOpened() const { return true; }
    virtual bool IsValid() const { return true; }
    virtual bool IsRedirector() const { return false; }
private:
    void checkDword(uint32_t value);
    int readMainHeader(uint_t);
    int readStreamHeader();
    void readStreams(uint_t);
    // int readMovieChunk();
    int readIndexChunk(uint_t, int movie_chunk_offset);
    void reconstructIndexChunk(int offset);
};

#endif // AVIFILE_AVIMEDIAREADHANDLER_H
