#ifndef AVIPLAY_AVIREADSTREAMA_H
#define AVIPLAY_AVIREADSTREAMA_H

#include "AviReadStream.h"

class IAudioDecoder;

class AviReadStreamA : public AviReadStream
{
    IAudioDecoder* audiodecoder;
public:
    AviReadStreamA(streamid_t id, IMediaReadStream* stream);
    ~AviReadStreamA() { StopStreaming(); }
    HRESULT GetAudioFormatInfo(void* bi, char** ext) const;
    uint_t GetFrameSize() const;
    HRESULT GetOutputFormat(void* format, uint_t size) const;
    framepos_t GetPos() const;
    double GetTime(framepos_t frame = ERR) const;
    bool IsStreaming() const;
    HRESULT ReadFrames(void* buffer, uint_t bufsize, uint_t samples,
		       uint_t& samples_read, uint_t& bytes_read);
    HRESULT StartStreaming();
    HRESULT StopStreaming();
};

#endif // AVIPLAY_AVIREADSTREAMA_H
