/*****************************************************************

  i_avifile.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Avi decoder for gmerlin
// Uses the avifile library (http://divx.euro.ru)

class GVInputAvifile : public GVInput
  {
  int colorspace_mask;

  int frames_to_read;
  
  IAviReadFile * avifile;

  IAviReadStream * audio_stream;
  IAviReadStream * video_stream;

  StreamInfo * audio_stream_info;
  StreamInfo * video_stream_info;
  
  void fill_audio_buf(GVAudioFrame * frame);
  void fill_video_buf(GVVideoFrame * frame);

  // For info about codecs

  guint16 audio_format_tag;
  gint32 video_format_tag;

  int skip(int num_frames);
  
public:
  void set_colorspace(GVColorspace colorspace);

  int colorspace_supported(GVColorspace colorspace);
  
  GVInputAvifile();
  ~GVInputAvifile();
  void init();
  void seek(float percentage);
  void cleanup();
  void print_info(ostream & output);

  };
