/*****************************************************************

  i_cdaudio.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifdef __GNUG__
#pragma interface
#endif

// CD player for gmerlin
// This is like almost every cdplayer: It plays audio directly
// to the soundcard

#include "cdaudio_common.h"

class GVInputCdaudio : public GVCdaudioCommon
  {
  int current_cd_track;
  int start_cd_track;
  int end_cd_track;
  
  int current_playlist_track;

  int must_seek;
  float seek_percentage;
    
  void play(int startpos);

  class ConfigWindow : public GVConfigWindow
    {
    GVInputCdaudio * plugin;

  public:

    ConfigWindow(GVInputCdaudio * _plugin);
    virtual ~ConfigWindow();

    void get_values();
    void apply_values();
    };

  friend class ConfigWindow;
  
  ConfigWindow * config_window;
  
public:
  
  GVInputCdaudio();
  virtual ~GVInputCdaudio();
  
  // Init function (called after setting the input)
  void init();

  void seek(float percentage);
    
  void playback_func();

  void cleanup();

  void configure();
  void print_info(ostream & output);
  
  };
