/*****************************************************************

  i_mpeg.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Mpeg decoder for gmerlin
// Uses the libmpeg3 library (http://heroines.sourceforge.net)

class GVInputMpeg : public GVInput
  {
  mpeg3_t * mpeg_file;

  void fill_audio_buf(GVAudioFrame * frame);

  void fill_video_buf(GVVideoFrame * frame);

  int searched; // We already searched, samplecount may be incorrect

  int skip(int num_frames);
    
public:

  int colorspace_supported(GVColorspace colorspace);

  void print_info(ostream & output);
    
  GVInputMpeg();
  void init();
  void seek(float percentage);
  void cleanup();
  };
