/*****************************************************************

  i_oss.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Plugin for recording from OSS soundcards

class GVInputOSS : public GVInput
  {
  GVAudioFormat config_format;
  int fd;
  int read_size;
  
  class ConfigWindow : public GVConfigWindow
    {
    GVConfigWidgetRecordtime record_time;
    GVConfigWidgetDevicelist device_widget;
    GVConfigWidgetSpinbutton samplerate;
    GVConfigWidgetOptionmenu channels;
    GVConfigWidgetOptionmenu bits;

    GVInputOSS * plugin;

  public:
    ConfigWindow(GVInputOSS * _plugin);
    void get_values();
    void apply_values();
    };
  
  friend class ConfigWindow;

  ConfigWindow * config_window;

  void fill_audio_buf(GVAudioFrame * frame);

  void get_config();
  void put_config();
  int open_device();

  void reset();
  
public:

  void init();
  void configure();
  void cleanup();

  void fill_playlist();
  
  ~GVInputOSS();
  GVInputOSS();
  };
