/*****************************************************************

  i_quicktime.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#ifdef __GNUG__
#pragma interface
#endif

// Quicktime decoder for gmerlin
// Uses the quicktime4linux library (http://heroines.sourceforge.net)

class GVInputQuicktime : public GVInput
  {
  quicktime_t * quicktime_file;

  int quicktime_info_present;
 
  void fill_audio_buf(GVAudioFrame * frame);

  void fill_video_buf(GVVideoFrame * frame);

  //  int searched; // We already searched, samplecount may be incorrect
  //  guint64 mpeg_audio_samples_written;

  int skip(int num_frames);
  
public:

  void print_info(ostream & output);
  
  
  int colorspace_supported(GVColorspace colorspace);
  
  GVInputQuicktime();
  ~GVInputQuicktime();
  void init();
  void seek(float percentage);
  void cleanup();
  };
