/*****************************************************************

  i_singlepic.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Base class for singlepic plugins 
// If you load 0001.jpg, it will search for 0002.jpg and so on
// The framerate is set in gv_global_config
// Derived classes must only define check_first_file(),
// get_frame(GVVideoFrame) and colorspace_supported()

class GVInputSinglepic : public GVInput
  {
  int offset;              // Number of the first filename
  
  char * filename_mask;    // Stuff after the number
  int num_digits;          // Number of digits to contruct the filename 
  
  int first_number;

  // Check the first file, set up best_colorspace and size of the picture
  // Return 0 on failure
  
  //  virtual int check_first_file() = 0;

  //  virtual void get_frame(GVVideoFrame * frame) = 0;
  
  void get_config();
  void put_config();

  GVImageReader * image_reader;
  
protected:

  char * current_filename;
  
public:

  GVInputSinglepic();
  ~GVInputSinglepic();

  void fill_video_buf(GVVideoFrame * frame);

  void set_trackname();
  
  void init();
  void cleanup();

  int colorspace_supported(GVColorspace colorspace);
  
  };
