/*****************************************************************

  ir_png.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// #ifdef __GNUG__
// #pragma interface
// #endif

// This one loads png files with Alpha
// It can be used in any case, where PNGs should be loaded
// (mostly for making a nicer GUI)

class GVImageReaderPNG : public GVImageReader
  {
  png_structp png_ptr;
  png_infop info_ptr;
  png_infop end_info;

  int png_bit_depth;
  int png_color_type;
  
public:

  GVImageReaderPNG();
  ~GVImageReaderPNG();

  int init(const char * filename, int first = 1);

  // Return true if colorspace is supported

  int colorspace_supported(GVColorspace colorspace);
  
  // Load image into the video frame structure. The frame must be
  // allocated with the proper size by the caller!!

  void load_image(GVVideoFrame * frame);

  // Cleanup all allocated resources. If the argument "last" is 0,
  // don't clean resources, which can be reused by series of pictures
  // in singlepicture plugins
  
  void cleanup(int last = 1);
  };
