/*****************************************************************

  audiodecoder.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#include <glib.h>
#include <string.h>
#include "source.h"
#include "fifo.h"
#include "toc.h"
#include "audio.h"

GVMpegAudioDecoder::GVMpegAudioDecoder(GVMpegFifo * _fifo)
  {
  fifo = _fifo;
  toc = (GVMpegToc*)0;
  input = (GVMpegInput*)0;
  }

void GVMpegAudioDecoder::seek(float percentage)
  {
  
  }

int GVMpegAudioDecoder::read_frame(guchar * ptr)
  {
  int frame_size = get_frame_size();

  int size_read;
  
  guchar * c_tmp = fifo->read_data(frame_size, &size_read);

  if(size_read >= frame_size)
    {
    memcpy(ptr, c_tmp, frame_size);
    return frame_size;
    }
  else
    return 0;
  }
