/*****************************************************************

  demuxer.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

class GVMpegSource;

class GVMpegDemuxer : public GVMpegSource
  {

  GVMpegToc * toc;
  
  void build_toc();

  GVMpegSource * source;

  int pack_header();
  int pack();
  int pes_packet();

  guint32 read_timestamp();
  
public:

  GVMpegFifo audio_fifo;
  GVMpegFifo video_fifo;
  GVMpegFifo * fifo;
  
  GVMpegDemuxer(GVMpegFifo * _fifo);
  virtual ~GVMpegDemuxer() {};

  
  
  int init();
  
  
  // Works only for multiplexed streams
  
  void seek(float percentage);  

  friend class GVMpegDecoder;

  };
