/*****************************************************************

  in_file.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#include <fstream.h>

class ifstream;

class GVMpegInputFile : public GVMpegInput
  {
  char * filename;
  
  ifstream file;
  
  guint64 read_block();

  virtual void real_seek(gint64 block_number);

  void read_id3_tags();

  GVTrackInfo * track_info;
  
public:

  const GVTrackInfo * get_track_info() const;
  
  
  // Check if filename matches a suffix
  
  int check_suffix(const char * suffix) const;
  
  // Open the file, return 1 on success
  
  int open(const char * arg);
  void close();

  GVMpegInputFile();
  virtual ~GVMpegInputFile();
       
  };
