/*****************************************************************

  in_http.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#include <glib.h>
#include <unistd.h>
#include <string.h>
#include "../../socket.h"

#include "source.h"
#include "fifo.h"
#include "input.h"
#include "in_http.h"



#define HTTP_BLOCK_SIZE 1024

guint64 GVMpegInputHttp::read_block()
  {
  ssize_t result = socket.read_raw((char*)read_buffer, block_size);
  if(result == -1)
    return 0;
  return result;
  }

// Open the file, arg is a complete URL

int GVMpegInputHttp::open(const char * arg)
  {
  GVMpegInput::init();
  if(strncmp(arg, "http://", strlen("http://")))
    return 0;
  return socket.open_url(arg, "audio/mpeg");
  }

void GVMpegInputHttp::close()
  {
  socket.close();
  }

GVMpegInputHttp::GVMpegInputHttp() :
  GVMpegInput(HTTP_BLOCK_SIZE)
  {
  flags = 0;
  }

GVMpegInputHttp::~GVMpegInputHttp()
  {

  }
       

