#ifdef __GNUG__
#pragma interface
#endif

// Base class for all input plugins
// This handles the audio and video formats
// and gets gmerlin-type frames from the decoders

class GVInputMpegCommon : public GVInput
  {
protected:
  
  void fill_audio_buf(GVAudioFrame * frame);
  
  void fill_video_buf(GVVideoFrame * frame);
  
  GVMpegDecoder mpeg_decoder;

  // This checks for audio and video and sets up the formats
  
  void init_common();
  void cleanup_common();

  GVInputMpegCommon(const GVPluginAttributes * _attributes);

  void print_info_common(ostream & output);

  
public:

  void seek(float percentage);
  
  void print_info(ostream & output);
  
  int colorspace_supported(GVColorspace colorspace);
  const GVTrackInfo * get_track_info();

  };
