/*****************************************************************

  o_quicktime.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Quicktime file writer

#ifdef __GNUG__
#pragma interface
#endif

class GVOutputQuicktime : public GVOutput
  {
  quicktime_t * quicktime_file;

  int write_raw_audio;
  
  void put_frame(GVAudioFrame * frame);
  void put_frame(GVVideoFrame * frame);

  char * audio_fourcc;
  char * video_fourcc;

  char * quicktime_info;
  char * quicktime_copyright;
    
  class ConfigWindow : public GVConfigWindow
    {
    GtkWidget * table;
    
    GVOutputQuicktime * plugin;
    GVConfigWidgetOptionmenu audio_codec;

    GVConfigWidgetOptionmenu video_codec;

    GVConfigWidgetSlider jpeg_quality;
    
    GVConfigWidgetString quicktime_copyright;
    GVConfigWidgetString quicktime_info;

    
  public:

    void get_values();
    void apply_values();
    
    ConfigWindow(GVOutputQuicktime * _plugin);
    virtual ~ConfigWindow();
    };

  friend class ConfigWindow;

  ConfigWindow * config_window;

  int jpeg_quality; // Jpeg quality (1..100)
  
public:

  void configure();
    
  GVOutputQuicktime();
  virtual ~GVOutputQuicktime();
  void init();
  void cleanup();

  void get_config();
  void put_config();
  };
