/*****************************************************************

  oa_esd.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// ESounD output driver

class GVOutputAudioEsound : public GVOutputAudio
  {
  int esd_socket;
  int esd_format;
  int esd_pause;    // This is 1 during pause
  
  char * esd_host;

  class ConfigWindow : public GVConfigWindow
    {
    GVOutputAudioEsound * plugin;
    GVConfigWidgetString host;
    
  public:

    ConfigWindow(GVOutputAudioEsound * _plugin);
    virtual ~ConfigWindow();

    void get_values();
    void apply_values();
    };

  friend class ConfigWindow;

  ConfigWindow * config_window;
  
  void get_config();
  void put_config();

  // Open the esd socket, return 0 on failure
  
  int open();

  void reset();
  
public:

  GVOutputAudioEsound();
  virtual ~GVOutputAudioEsound();
    
  void init();

  void put_frame(GVAudioFrame * frame);

  void cleanup();

  void print_info(ostream & output);

  void configure();
  
  };
