/*****************************************************************

  oa_oss.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// OSS Audio driver

class GVOutputAudioOSS : public GVOutputAudio
  {
  char * device1;
  char * device2;
  char * device3;

  int fd1; // File descriptor
  int fd2; // File descriptor
  int fd3; // File descriptor

  //  int buffer_size;
  
  int old_bytes_played;

  GVTime current_track_time;
  GVTime lastPutTime ;  
  pthread_mutex_t fd_mutex;

  void open_device(int init);
  void close_device();

  int mirror_rear;

  //  int write_size;
  
  class ConfigWindow : public GVConfigWindow
    {
    GVOutputAudioOSS * plugin;

    GVConfigWidgetFile devicename1;
    GVConfigWidgetFile devicename2;
    GVConfigWidgetFile devicename3;

    GtkWidget * mirror_rear;
    
    GtkWidget * table;
  public:

    ConfigWindow(GVOutputAudioOSS * _plugin);
    virtual ~ConfigWindow();

    void get_values();
    void apply_values();
    };

  friend class ConfigWindow;
  
  ConfigWindow * config_window;
   
public:

  void print_info(ostream & output);
  
  
  void get_current_track_time(GVTime & old_time);
  
  void init();

  void reset();
  
  GVOutputAudioOSS();
  virtual ~GVOutputAudioOSS();
  
  // Write one frame to the soundcard

  void put_frame(GVAudioFrame * frame);
  void cleanup();
  void configure();
  };
