/*****************************************************************

  oa_sndfile.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// sndfile output plugin

#ifdef __GNUG__
#pragma interface
#endif

extern "C" {
#include "libsndfile/src/sndfile.h"
}

// GV Interface for the lame mp3 encoder

class GVOutputAudioSndfile : public GVOutputAudio
  {
  SNDFILE * file;
  SF_INFO file_info;

  void get_config();
  void put_config();
    
  void put_frame(GVAudioFrame * frame);

  class ConfigWindow: public GVConfigWindow
    {
    GVOutputAudioSndfile * plugin;

    GVConfigWidgetOptionmenu format_menu;
    GVConfigWidgetOptionmenu subformat_menu;
    
    GtkWidget * table;
    
  public:

    ConfigWindow(GVOutputAudioSndfile * _plugin);
    virtual ~ConfigWindow();
    void get_values();
    void apply_values();
    
    };

  friend class ConfigWindow;
  
  ConfigWindow * config_window;

public:

  void configure();

  void init();

  void cleanup();
  
  GVOutputAudioSndfile();
  virtual ~GVOutputAudioSndfile();
  
  };
