/*****************************************************************

  oa_vorbis.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Ogg Vorbis encoder for gmerlin

// Most of the code you find here, is either standard gmerlin plugin stuff
// or things I copied from the vorbis example encoder. By the way, I have
// not the slightest idea, of what's really happening here :)

#ifdef __GNUG__
#pragma interface 
#endif

class GVOutputAudioVorbis : public GVOutputAudio
  {
  ogg_stream_state os; /* take physical pages, weld into a logical
                          stream of packets */
  ogg_page         og; /* one Ogg bitstream page.  Vorbis packets are inside */
  ogg_packet       op; /* one raw packet of data for decode */
  
  vorbis_info      vi; /* struct that stores all the static vorbis bitstream
                          settings */
  vorbis_comment   vc; /* struct that stores all the user comments */

  vorbis_dsp_state vd; /* central working state for the packet->PCM decoder */
  vorbis_block     vb; /* local working space for packet->PCM decode */

  GVTrackInfo default_track_info;

  ofstream output;
  
  // Build the comment from the track info
  
  void build_comment();
  
  void get_config();
  void put_config();
    
  void put_frame(GVAudioFrame * frame);

  class ConfigWindow: public GVConfigWindow
    {
    GVConfigWidgetString default_artist;
    GVConfigWidgetString default_album;
    GVConfigWidgetString default_title;
    GVConfigWidgetSpinbutton default_track_number;
    GVConfigWidgetString default_genre;
    GVConfigWidgetString default_comment;

    GtkWidget * use_default_artist;
    GtkWidget * use_default_album;
    GtkWidget * use_default_title;
    GtkWidget * use_default_track_number;
    GtkWidget * use_default_genre;
    GtkWidget * use_default_comment;
    
    GVOutputAudioVorbis * plugin;
    
    GtkWidget * table;

    GVConfigWidgetOptionmenu bitrate;
    
  public:

    ConfigWindow(GVOutputAudioVorbis * _plugin);
    virtual ~ConfigWindow();
    void get_values();
    void apply_values();
    
    };

  int build_comment_flags;
 
  int bitrate;
  
  friend class ConfigWindow;
  
  ConfigWindow * config_window;

public:

  void configure();

  void init();

  void cleanup();
  
  GVOutputAudioVorbis();
  virtual ~GVOutputAudioVorbis();
  };
