/*****************************************************************

  oss_common.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

#include "../gv.h"

#include <sys/soundcard.h>

int oss_get_sample_format(const GVAudioFormat & format)
  {
  int ret = 0;
  switch(format.sample_type)
    {
    case GVAudio_8_signed:
      ret = AFMT_S8;
      break;
    case GVAudio_16_signed:
      switch(format.endian_format)
        {
        case GVBigEndian:
          ret = AFMT_S16_BE;
          break;
        case GVLittleEndian:
          ret = AFMT_S16_LE;
          break;
        }
      break;
    case GVAudio_8_unsigned:
      ret = AFMT_U8;
      break;
    case GVAudio_16_unsigned:
      switch(format.endian_format)
        {
        case GVBigEndian:
          ret = AFMT_U16_BE;
          break;
        case GVLittleEndian:
          ret = AFMT_U16_LE;
          break;
        }
    }
  return ret;
  }
