/*****************************************************************

  skinbrowser.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Skin browser

#ifdef __GNUG__
#pragma interface
#endif

class GVLabel;

class GVSkinBrowser : public GVConfigWindow
  {
  struct SkinInfo
    {
    char * name;
    char * filename;
    };

  //  GList * skins;
  
  GVSkin * display_skin;
  
  GtkWidget * skinlist;
  GVLabel * description;
  
  GtkWidget * preview_drawingarea;
  
  void read_skins(const char * directory_name);

  int preview_width;
  int preview_height;

  int drawingarea_width;
  int drawingarea_height;
  
  char * current_skin_file;
  const char * display_skin_file;
    
public:

  GVSkin * current_skin;
  
  GVSkinBrowser();
  ~GVSkinBrowser();
  
  void apply_values();
  void get_values();
  void select_row_callback(int row);
  void expose_callback();

  };

extern GVSkinBrowser * gv_skin_browser;
