/*****************************************************************

  slider.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Gmerlins seek slider

class GVSlider
  {
  GtkWidget * slider; // GtkDrawingarea
  GtkWidget * background;
  
  float percentage;

  int max_x_offset;  // Maximum x offset of the slider
  int x_offset;  // current x offset
  //  int y_offset;  // current x offset
  
  GdkPixmap * background_pixmap;

  GdkPixmap * slider_pixmap;
  GdkPixmap * slider_pixmap_highlight;
  GdkBitmap * slider_mask;

  int seek_active;
  int seek_x;
  int sensitive;
  int highlight;
  
  int slider_width;
  int slider_height;
  int background_width;
  int background_height;
    
public:

  void set_sensitive(int _sensitive) { sensitive = _sensitive; }
  void set_visible(int visible);
  
  void (*change_callback)(float percentage, gpointer data);
  void (*seek_callback)(float percentage, gpointer data);

  gpointer change_callback_data;
  gpointer seek_callback_data;
    
  GVSlider();
  
  GtkWidget * widget; // GtkLayout
  
  void set_pixmaps(GdkPixmap * _background_pixmap,
                   GdkPixmap * _slider,
                   GdkPixmap * _slider_highlight,
                   GdkBitmap * _slider_mask);

  void notify_callback(GdkEventAny * w);
  void button_callback(GtkWidget * w, GdkEventButton * evt);
  void motion_callback(GdkEventMotion * evt);
  void expose_callback(GtkWidget * w);
  void set_style_callback();

  void set_percentage(float percentage);
  float get_percentage();
  void realize();
  
  };
