/*****************************************************************

  socket.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Socket class
// This should be used whenever gmerlin connects to another
// computer

class ostream;

class GVSocket
  {
  char * servername;
  int real_port;     // Real port for cennecting via a proxy

  // A list containing the lines of the (e.g. http-)  header 
  
  GList * header;
  
public:

  int keep_header;

  void free_header();
  const char * get_header_key(const char * key);
  
  GVSocket();
  
  int sock;

  // Raw open function
  
  void open(char * hostname, int port);

  // URL open function
  // This should handle different protocols (http, ftp...)

  int open_url(const char * url, const char * accept_type);
  
  void close();

  void send_http_request(const char * request, const char * accept_type);
  int skip_http();
  
  void read_line(ostream & output);
  ssize_t read_raw(char * buffer, size_t size);
  
  };
