/*****************************************************************

  videobuf.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// Video FIFO buffer

// #ifdef __GNUG__
// #pragma interface
// #endif

#define GV_VIDEO_BUFFER_INPUT_LOCKED  (1<<0)
#define GV_VIDEO_BUFFER_OUTPUT_LOCKED (1<<1)
#define GV_VIDEO_BUFFER_FULL          (1<<2)
#define GV_VIDEO_BUFFER_EMPTY         (1<<3)

#define GV_BUFFER_VIDEO_CONVERT                      (1<<0)

class GVOutputVideo;
class GVVideoConverter;

// Video buffer for a single frame

class GVBufferVideo : public GVBuffer<GVVideoFrame,GVVideoFormat>
  {

  // Coordinates for scaling

//   int in_x; 
//   int in_y;
//   int in_w; 
//   int in_h;
//   int out_x; 
//   int out_y; 
//   int out_w; 
//   int out_h;
//   int total_in_w;
//   int total_out_w;
//   int bg_color;

  void clear_frame(GVVideoFrame * frame, const GVVideoFormat * format);
  
  void alloc_frame(GVVideoFrame * frame, const GVVideoFormat * format);
  void free_frame(GVVideoFrame * frame, const GVVideoFormat * format);

  void convert(GVVideoFrame * src, GVVideoFrame * dst);

  int need_scratch() { return !!convert_mode; }
  
  int output_can_alloc();
  int input_can_alloc();

  void set_formats();

  GVVideoConverter * converter;
  
  public:
 
  GVBufferVideo();
  virtual ~GVBufferVideo();
  };
