/*****************************************************************

  xmanager.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// This manages some Gdk/X stuff

// - gets the default colorspace of the X Display
// - Converts GVVideoFrames into GdkPixmaps (with mask)

class GVVideoConverter;

class GVXManager
  {
  GdkWindow * window; // This is used fot crating pixmaps and bitmaps

  GdkGC * gc;
  
  GVColorspace colorspace;
  GVVideoConverter * video_converter;

  int window_depth; // Depth of windows (returned by gdk_window_get_geometry)

  GdkBitmap * get_bitmap(const GVVideoFrame * frame,
                         const GVVideoFormat * video_format);
  
public:
  
  GdkGC * get_gc() { return gc; }

  GdkCursor * move_cursor;
  
  void alloc_video_frame(GVVideoFrame * video_frame,
                         const GVVideoFormat * format);
  
  void free_video_frame(GVVideoFrame * video_frame);
  
  GVColorspace get_colorspace() { return colorspace; }
  int get_window_depth() { return window_depth; }
  
  GVXManager();

  // This is the routine for loading image files into GdkPixmaps

  GdkPixmap * load_image(const char * filename, GdkBitmap ** mask);

  // This is the icon for all gmerlin windows

  GdkPixmap * gmerlin_icon;
  GdkBitmap * gmerlin_icon_mask;
  
  
  };

extern GVXManager * gv_x_manager;
