/*****************************************************************

  xvwrapper.cc

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// This is stupid: It causes gmerlin to be linked statically with libXv
// so that dynamic loading of the X11 plugin works

#include "config.h"
#include "xvwrapper.h"

XvImage * gv_XvShmCreateImage(Display *display, XvPortID port,
                              int id, char* data, int width, int height,
                              XShmSegmentInfo *shminfo)
  {
  return XvShmCreateImage(display, port, id, data, width, height, shminfo);
  }


int gv_XvGrabPort(Display * display, XvPortID port, Time time)
  {
  return XvGrabPort(display, port, time);
  }

int gv_XvUngrabPort(Display * display, XvPortID port, Time time)
  {
  return XvUngrabPort(display, port, time);
  }

int gv_XvShmPutImage(Display *display, XvPortID id, Drawable d,
                     GC gc, XvImage *image, int src_x, int src_y,
                     unsigned int src_w, unsigned int src_h,
                     int dest_x, int dest_y, unsigned int dest_w,
                     unsigned int dest_h, Bool send_event)
  {
  return XvShmPutImage(display, id, d, gc, image, src_x, src_y,
                       src_w, src_h, dest_x, dest_y, dest_w,
                       dest_h, send_event);
  }

int gv_XvStopVideo(Display * display, XvPortID port, Drawable d)
  {
  return XvStopVideo(display, port, d);
  }

int gv_XvQueryExtension(Display* display, unsigned int* p_version,
                     unsigned int* p_revision, unsigned int* p_requestBase,
                     unsigned int* p_eventBase , unsigned int* p_errorBase)
  {
  return XvQueryExtension(display, p_version, p_revision, p_requestBase,
                          p_eventBase, p_errorBase);
  }

int gv_XvQueryAdaptors(Display* display, Window window, unsigned int* p_nAdaptors,
                       XvAdaptorInfo** p_pAdaptors)
  {
  return XvQueryAdaptors(display, window, p_nAdaptors, p_pAdaptors);
  }

int gv_XvQueryEncodings(Display* display, XvPortID port, unsigned int* p_nEncoding,
                        XvEncodingInfo** p_pEncoding)
  {
  return XvQueryEncodings(display, port, p_nEncoding, p_pEncoding);
  }

void gv_XvFreeEncodingInfo(XvEncodingInfo* encodings)
  {
  XvFreeEncodingInfo(encodings);
  }

XvImageFormatValues * gv_XvListImageFormats(Display *display, XvPortID port_id,
                                            int *count_return)
  {
  return XvListImageFormats(display, port_id, count_return);
  }

void gv_XvFreeAdaptorInfo(XvAdaptorInfo* adaptors)
  {
  XvFreeAdaptorInfo(adaptors);
  }

