/*****************************************************************

  xvwrapper.h

  Copyright (c) 2001 by Burkhard Plaum - plaum@ipf.uni-stuttgart.de

  http://gmerlin.sourceforge.net

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

*****************************************************************/

// This one's really stupid: Since Xfree86 has no dynamic version
// of libXv, I have to write these wrapper functions for the Xv functions
// These cause libXv to be linked statically into the gmerlin executeable,
// since the wrapper functions can be called from the module

#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/extensions/Xvlib.h>

XvImage * gv_XvShmCreateImage(Display *display, XvPortID port,
                              int id, char* data, int width, int height,
                              XShmSegmentInfo *shminfo);

int gv_XvGrabPort(Display * display, XvPortID port, Time time);
int gv_XvUngrabPort(Display * display, XvPortID port, Time time);

int gv_XvShmPutImage(Display *display, XvPortID id, Drawable d,
                  GC gc, XvImage *image, int src_x, int src_y,
                  unsigned int src_w, unsigned int src_h,
                  int dest_x, int dest_y, unsigned int dest_w,
                  unsigned int dest_h, Bool send_event);

int gv_XvStopVideo(Display * display, XvPortID port, Drawable d);

int gv_XvQueryExtension(Display* display, unsigned int* p_version,
                        unsigned int* p_revision, unsigned int* p_requestBase,
                        unsigned int* p_eventBase , unsigned int* p_errorBase);

int gv_XvQueryAdaptors(Display* display, Window window, unsigned int* p_nAdaptors,
                       XvAdaptorInfo** p_pAdaptors);

int gv_XvQueryEncodings(Display* display, XvPortID port, unsigned int* p_nEncoding,
                        XvEncodingInfo** p_pEncoding);

void gv_XvFreeEncodingInfo(XvEncodingInfo* encodings);

XvImageFormatValues * gv_XvListImageFormats(Display *display, XvPortID port_id,
                                            int *count_return);

void gv_XvFreeAdaptorInfo(XvAdaptorInfo* adaptors);
